// Techniques.cpp : implementation file
//

#include "stdafx.h"
#include "hh4mfc.h"
#include "Techniques.h"

#include "htmlhelp.h"
#include "stdlib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTechniques dialog


CTechniques::CTechniques(CWnd* pParent /*=NULL*/)
	: CDialog(CTechniques::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTechniques)
	m_TopicID = _T("1030");
	m_TopicURL = _T("html\\topicurl.htm");
	m_ALink = _T("bugaboo");
	m_Keyword = _T("keyword");
	m_DefaultText = _T("The requested topic could not be found.");
	m_DefaultTitle = _T("Topic Not Found");
	m_DefaultTopic = _T("html\\_topic_not_found.htm");
	m_ShowTopic = 0;
	//}}AFX_DATA_INIT
}


void CTechniques::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTechniques)
	DDX_Text(pDX, IDC_TOPIC_ID, m_TopicID);
	DDV_MaxChars(pDX, m_TopicID, 12);
	DDX_Text(pDX, IDC_TOPIC_URL, m_TopicURL);
	DDX_Text(pDX, IDC_A_LINK, m_ALink);
	DDX_Text(pDX, IDC_KEY_WORD, m_Keyword);
	DDX_Text(pDX, IDC_DEFAULT_TEXT, m_DefaultText);
	DDX_Text(pDX, IDC_DEFAULT_TITLE, m_DefaultTitle);
	DDX_Text(pDX, IDC_DEFAULT_TOPIC, m_DefaultTopic);
	DDX_Radio(pDX, IDC_SHOW_TOPIC, m_ShowTopic);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTechniques, CDialog)
	//{{AFX_MSG_MAP(CTechniques)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_ID_HELP, OnIdHelp)
	ON_BN_CLICKED(IDC_KEYWORD, OnKeyword)
	ON_BN_CLICKED(IDC_ALINK, OnAlink)
	ON_BN_CLICKED(IDC_URL_HELP, OnUrlHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTechniques message handlers

afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);

BOOL CTechniques::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// Only show the popup if the HelpID property
	// of the control is set.
	if (pHelpInfo->dwContextId > 0)
	{
		ShowContextHelp(CWnd::FromHandle((HWND)pHelpInfo->hItemHandle), 
			pHelpInfo->MousePos, pHelpInfo->dwContextId);
	}
 return TRUE;  
}

void CTechniques::ShowContextHelp(CWnd* pWnd, POINT pt, int iCtrlID)
{
	HH_POPUP popup ;
	POINT ptPoint ;
	RECT rRect ;
	
	// Set the popup's margins
	rRect.top = -1 ;
	rRect.left = -1 ;
	rRect.bottom = -1 ;
	rRect.right = -1 ;

	GetCursorPos(&ptPoint);

	memset(&popup, 0, sizeof(HH_POPUP));
    popup.cbStruct = sizeof(HH_POPUP);
	popup.hinst = 0;
	popup.idString = iCtrlID;      
    popup.pszText = "";       
    popup.pt = pt;
    popup.clrForeground = 0; 
    popup.clrBackground = RGB(255, 255, 208); 
    popup.rcMargins = rRect;     
    popup.pszFont = "Arial, 8, ascii, , , ";
    
	HtmlHelp(pWnd->GetSafeHwnd(), "hh4mfc.chm::/popups.txt", 
		HH_DISPLAY_TEXT_POPUP, (DWORD)&popup);
}

void CTechniques::OnIdHelp() 
{
	CWnd* pWnd = GetDlgItem(IDC_TOPIC_ID);
	pWnd->GetWindowText(m_TopicID);

	HtmlHelp(
		0,
        "hh4mfc.chm>tripane",
        HH_HELP_CONTEXT,
        atol(m_TopicID)) ;
}

void CTechniques::OnUrlHelp() 
{
	CWnd* pWnd = GetDlgItem(IDC_TOPIC_URL);
	pWnd->GetWindowText(m_TopicURL);

	HtmlHelp(
		0,
        "hh4mfc.chm::/" + m_TopicURL,
        HH_DISPLAY_TOPIC,
        NULL) ;
}

void CTechniques::OnKeyword() 
{
	HH_AKLINK link;
	
	// Change the following value to switch from a default
	// "topic not found" topic to a message box.
	bool CHECKVALUE = TRUE;
	
	// Delete the following line if you want the Topics Found
	// dialog to be displayed.
	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_DISPLAY_TOPIC,
        NULL) ;

	link.cbStruct =     sizeof(HH_AKLINK) ;
	link.fReserved =    FALSE ;

	// Change the following keyword to see what happens when the
	// topic isn't found.
	CWnd* pWnd = GetDlgItem(IDC_KEY_WORD);
	pWnd->GetWindowText(m_Keyword);

	link.pszKeywords =  m_Keyword ;

	int m_ShowDefaultTopic = GetCheckedRadioButton(IDC_SHOW_TOPIC, IDC_SHOW_MSGBOX);
	
	if (m_ShowDefaultTopic == IDC_SHOW_TOPIC)
	{
		CWnd* pWnd = GetDlgItem(IDC_DEFAULT_TOPIC);
		pWnd->GetWindowText(m_DefaultTopic);

		link.pszUrl =       m_DefaultTopic ; 
		link.pszMsgText =   NULL ; 
		link.pszMsgTitle =  NULL ;
	}	
	else
	{
		link.pszUrl =       NULL ;
		
		CWnd* pWnd = GetDlgItem(IDC_DEFAULT_TEXT);
		pWnd->GetWindowText(m_DefaultText);
		
		link.pszMsgText =   m_DefaultText ;
		
		CWnd* pWnd2 = GetDlgItem(IDC_DEFAULT_TITLE);
		pWnd2->GetWindowText(m_DefaultTitle);
		
		link.pszMsgTitle =  m_DefaultTitle ;
	}

	link.pszWindow =    "tripane" ;
	link.fIndexOnFail = FALSE ;

	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_KEYWORD_LOOKUP,
        (DWORD)&link);
}

void CTechniques::OnAlink() 
{
	HH_AKLINK link;
	
	// Change the following value to switch from a default
	// "topic not found" topic to a message box.
	bool CHECKVALUE = FALSE;

	link.cbStruct =     sizeof(HH_AKLINK) ;
	link.fReserved =    FALSE ;
	
	// Delete the following line if you want the Topics Found
	// dialog to be displayed.
	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_DISPLAY_TOPIC,
        NULL) ;

	// Change the following keyword to see what happens when the
	// topic isn't found.
	CWnd* pWnd = GetDlgItem(IDC_A_LINK);
	pWnd->GetWindowText(m_ALink);

	link.pszKeywords =  m_ALink ;
	
	int m_ShowDefaultTopic = GetCheckedRadioButton(IDC_SHOW_TOPIC, IDC_SHOW_MSGBOX);
	
	if (m_ShowDefaultTopic == IDC_SHOW_TOPIC)
	{
		CWnd* pWnd = GetDlgItem(IDC_DEFAULT_TOPIC);
		pWnd->GetWindowText(m_DefaultTopic);

		link.pszUrl =       m_DefaultTopic ; 
		link.pszMsgText =   NULL ; 
		link.pszMsgTitle =  NULL ;
	}
	else
	{
		CWnd* pWnd = GetDlgItem(IDC_DEFAULT_TEXT);
		pWnd->GetWindowText(m_DefaultText);
		
		link.pszMsgText =   m_DefaultText ;
		
		CWnd* pWnd2 = GetDlgItem(IDC_DEFAULT_TITLE);
		pWnd2->GetWindowText(m_DefaultTitle);
		
		link.pszMsgTitle =  m_DefaultTitle ;
	}

	link.pszWindow =    "tripane" ;
	link.fIndexOnFail = FALSE ;

	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_ALINK_LOOKUP,
        (DWORD) &link) ;

}
